<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">
		<meta content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" name="viewport">
	
		<title>02. GIT</title>
	
		<link href="dist/reset.css" rel="stylesheet">
		<link href="dist/reveal.css" rel="stylesheet">
		<link href="dist/theme/odisee.css" rel="stylesheet">

		<!-- Theme used for syntax highlighted code -->
		<link href="plugin/highlight/monokai.css" rel="stylesheet">
	
		<script src="https://unpkg.com/vue@next"></script>
	</head>

	<body>
		<div class="slides-navigation">
			<a href="index.html"><i hidden="true" class="fas fa-arrow-left"></i>Back to index</a>
		</div>
		
		<div class="reveal">
			<!-- Any section element inside of this container is displayed as a slide -->
			<div class="slides">


				<!-- Title -->
				<section>
					
						<h3 class="inverted">Introduction to version control</h3>
						<h1>Git</h1>
				
					
				</section>

				<!-- Built-in Service Provider: Swift -->
				<section>
					<section>
						<h2 style="visibility: hidden;">Intro</h2>

						<p><img src="assets/git/git-logo-white.png" width="447" alt="" class="noborder" style="margin-top: 3em;" /></p>

						<p class="fragment dontunfragment" style="position: absolute; top: 25%; left: 10%; right: 10%; bottom: 10%; transform: rotate(-2deg);"><img src="assets/git/barfing-rainbow.gif" width="447" alt="What you guys think of it" class="noborder" /></p>

						<p class="fragment dontunfragment" style="position: absolute; top: 25%; left: 10%; right: 10%; bottom: 10%; transform: rotate(2deg);"><img src="assets/git/obama-not-bad.png" width="447" alt="What I think of it" class="noborder" /></p>

					</section>

					<section>
						<h2>What is Git?</h2>
						<blockquote class="fragment">Git is a free and open source distributed version control system designed to handle everything from small to very large projects with speed and efficiency.</blockquote>
						<ul>
							<li class="fragment" style="margin-top: 1em;">
								Version control system
								<ul>
									<li class="fragment">Tell it to keep track of certain files</li>
									<li class="fragment">Save the state of files in a historical timeline (<strong>repository</strong>)</em></li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 0.4em;">
								Distributed
								<ul>
									<li class="fragment">Works offline</li>
									<li class="fragment">
										Several users have their own separate file history
										<ul>
											<li class="fragment">These can later on be <strong>merged</strong></li>
										</ul>
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Installation &amp; Basic Configuration</h2>
						<ul>
							<li class="fragment">
								Download the Git binary from <a href="http://git-scm.com">git-scm.com</a>
								<ul>
									<li>On Windows, choose &ldquo;Run Git and included Linux tools from the Windows Command Prompt&rdquo;</em> during installation</li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Once installed, tell Git who you are
								<pre class="bigger"><code data-trim>
$ git config --global user.name "Lorem Ipsum"
$ git config --global user.email lorem@ips.um</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Git GUIs</h2>
						<ul>
							<li class="fragment">
								Git is shipped with some (very)</em> basic GUI tools
								<ul>
									<li><code>gitk</code>, <code>git-gui</code></li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Other Git GUIs also exist
								<ul>
									<li>Windows: <a href="http://www.sourcetreeapp.com/">Sourcetree</a>, VScode, SmartGit, etc.</li>
									<li>OS X: <a href="http://www.sourcetreeapp.com/">Sourcetree</a>, <a href="http://www.git-tower.com/">Tower</a> (paid)</em>, etc.</li>
								</ul>
							</li>
						</ul>
						<ul class="fragment">Whilst these GUIs are a nice addition, we'll focus on the command line</ul>
					</section>

				</section>

				<section>

					<section>
						<h2>Getting started</h2>
						<p><img src="assets/git/futurama-max.png" width="447" alt="" class="noborder" /></p>
						<q>
							Thank you, thank you. Let's get started. Max, play me over.<br />
							(gasps) Looks like someone forgot to feed Max!
						</q>
					</section>

					<section>
						<h2>Creating a repository</h2>

						<ul>
							<li class="fragment" >
								Start tracking files in a directory with <code>git init</code>
								<pre ><code data-trim >
~/ikdoeict/git-demo
$ git init
Initialized empty Git repository in /Users/roelvs/git-demo/.git/

~/ikdoeict/git-demo
$ </code></pre>
								<ul>
									<li class="fragment">
										Git automatically creates a (hidden) <code>.git</code> folder containing
										<ul>
											<li>Meta information</li>
											<li>The entire history</li>
											<li>&hellip;</li>
										</ul>
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Checking the status of a repository</h2>

						<ul>
							<li class="fragment">
								Git knows whenever a file has changed in the repository
							</li>
							<li class="fragment">
								Use <code>git status</code> to check
								<pre ><code  class="shell" data-line-numbers="2|5-11" data-trim>
~/ikdoeict/git-demo
$ touch test.txt

$ ~/ikdoeict/git-demo
$ git status
# &hellip;
#
# Untracked files:
# &hellip;
#	test.txt
#
</code></pre>
							</li>
							<li class="fragment">
								Git compares the current state of the <strong>working directory</strong> to the last state stored in the history
							</li>
						</ul>
					</section>


					<section>
						<h2>Staging &amp; committing</h2>
						<ul>
							<li class="fragment">
								To save the changes into the history timeline
								<ol>
									<li class="fragment">Select which files you want to save using <code>git add</code> &rarr; <strong>staging</strong></li>
									<li class="fragment">Actually save them using <code>git commit</code> &rarr; <strong>committing</strong></li>
								</ol>
								<pre class="bigger fragment"><code class="shell" data-line-numbers="1-2|4-8" data-trim >
~/ikdoeict/git-demo
$ git add test.txt

~/ikdoeict/git-demo
$ git commit -m 'Start tracking test.txt'
[main (root-commit) 9c43f96] Start tracking test.txt
 0 files changed
 create mode 100644 test.txt
</code></pre>
							</li>
							<li class="fragment">
								The current state (actually: a delta)</em> of <code>test.txt</code> is stored in the repository
								<ul>
									<li class="fragment">The commit is identified as <code>9c43f96</code></li>
								</ul>
							</li>
						</ul>
					</section>


					<section>
						<h2>Flow visualization</h2>
						<figure style="margin-top: 4em;" class="fragment">
							<img src="assets/git/git-add-commit.png" width="700" alt="" class="noborder" />
							<figcaption>Visual representation of staging and committing in Git</figcaption>
						</figure>
					</section>


					<section>
						<h2>Committing (1)</h2>
						<ul>
							<li class="fragment">
								Only staged files are committed
								</li>
								</ul>
								<pre ><code class="shell" data-trim data-line-numbers="1-2|4-5|7-17|19-20|22-32|34-38|40-46|1-46" >
~/ikdoeict/git-demo on main
$ touch test2.txt

~/ikdoeict/git-demo on main
$ echo 'hello' >> test.txt

~/ikdoeict/git-demo on main*
$ git status
# On branch main
# Changes not staged for commit:
# &hellip;
#	modified:   test.txt
#
# Untracked files:
# &hellip;
#	test2.txt
#

~/ikdoeict/git-demo on main*
$ git add test2.txt

~/ikdoeict/git-demo on main*
$ git status
# On branch main
# Changes to be committed:
# &hellip;
#	new file:   test2.txt
#
# Changes not staged for commit:
# &hellip;
#	modified:   test.txt
#

~/ikdoeict/git-demo on main*
$ git commit -m 'Start tracking test2'
[main f1c6883] Start tracking test2
 0 files changed
 create mode 100644 test2.txt

~/ikdoeict/git-demo on main*
$ git status
# On branch main
# Changes not staged for commit:
# &hellip;
#	modified:   test.txt
#
</code></pre>
							
					</section>

					<section>
						<h2>Committing (2)</h2>
						<ul>
							<li class="fragment">
								Stage all files + commit them in one command
								<pre class="bigger fragment bash"><code class="shell">$ git commit -am 'commitmessage'</code></pre>
							</li>
							<li class="fragment">
								Don't create an extra commit when something was forgotten but amend</em> it
								<pre class="bigger fragment bash"><code class="shell">$ git commit --amend -m 'commitmessage'</code></pre>
							</li>

							<li class="fragment" style="margin-top: 1em">
								Write good commit messages
								<ul>
									<li>English</li>
									<li>Present tense</li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em">
								One commit = one set of changes
								<ul>
									<li>Don't commit 2 features/bugfixes/etc at once</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Commit history</h2>
						<ul>
							<li class="fragment">
								The entire commit history can be visualized as a timeline
							</li>
						</ul>
						<figure class="fragment">
							<img src="assets/git/git-timeline.png" alt="" title="" width="700" />
						</figure>

						<ul class="fragment">
							<li>
								Such a timeline is called a <strong>branch</strong>
								<ul>
									<li class="fragment">More than one branch can exist</li>
									<li class="fragment">The default branch is often called <strong>main</strong></li>
								</ul>
							</li>
						</ul>
						<figure class="fragment">
							<img src="assets/git/git-timeline-master.png" alt="" title="" width="700" />
						</figure>
					</section>


					<section>
						<h2>Staging &amp; Unstaging (1)</h2>
						<ul>
							<li class="fragment">
								Stage all files
								<pre class="bigger fragment bash"><code class="shell">$ git add .</code></pre>
							</li>
							<li class="fragment">
								Stage all <code>.txt</code> files
								<pre class="bigger fragment bash"><code class="shell">$ git add *.txt</code></pre>
							</li>
							<li class="fragment">
								Stage an entire subfolder
								<pre class="bigger fragment bash"><code class="shell">$ git add subfolder/</code></pre>
							</li>
							<li class="fragment">
								Unstage files
								<pre class="bigger fragment bash"><code class="shell">$ git reset filename</code></pre>
							</li>
						</ul>
					</section>


					<section>
						<h2>Visualization</h2>
						<figure style="margin-top: 4em;" class="fragment">
							<img src="assets/git/git-add-reset-commit.png" width="700" alt="" class="noborder" />
							<figcaption>Visual representation of staging, unstaging and committing in Git</figcaption>
						</figure>
					</section>


					<section>
						<h2>Staging &amp; Unstaging (2)</h2>
						<ul><li>Deletions are not staged by default</li></ul>
						<pre class="bigger fragment"><code class="shell" data-line-numbers="1-2|4-11|13-14|16-26|28-29|31-39|41-44|46-50|52-59|61-66|68-72" data-trim style="max-height: 380px; overflow: scroll;">
~/ikdoeict/git-demo on main
$ rm test2.txt

~/ikdoeict/git-demo on main
$ git status
# On branch main
# Changes not staged for commit:
#
#	modified:   test.txt
#	deleted:    test2.txt
#

~/ikdoeict/git-demo on main*
$ git add .

~/ikdoeict/git-demo on main*
$ git status
# On branch main
# Changes to be committed:
# &hellip;
#	modified:   test.txt
#
# Changes not staged for commit:
# &hellip;
#	deleted:    test2.txt
#

~/ikdoeict/git-demo on main*
$ git add -u .

~/ikdoeict/git-demo on main*
$ git status
# On branch main
# Changes to be committed:
# &hellip;
#	modified:   test.txt
#	deleted:    test2.txt
#
#

~/ikdoeict/git-demo on main*
$ git reset test.txt
Unstaged changes after reset:
M	test.txt

~/ikdoeict/git-demo on main*
$ git commit -m 'Deleted test2.txt'
[main 1d7a184] Deleted test2.txt
 0 files changed
 delete mode 100644 test2.txt

~/ikdoeict/git-demo on main*
$ git status
# On branch main
# Changes not staged for commit:
# &hellip;
#	modified:   test.txt
#
#

~/ikdoeict/git-demo on main*
$ ls
drwxr-xr-x   4 roelvs  staff  136 Mar 19 21:18 .
drwxr-xr-x  10 roelvs  staff  340 Mar 19 15:49 ..
drwxr-xr-x  13 roelvs  staff  442 Mar 19 21:24 .git
-rw-r--r--   1 roelvs  staff    6 Mar 19 20:44 test.txt

~/ikdoeict/git-demo on main*
$ git commit -am 'Hello'
[main c53f9b6] Hello
 1 file changed, 1 insertion(+)

~/ikdoeict/git-demo on main
$ </code></pre>
							<ul>
							<li class="fragment">
								Solution: use <code>git add -u</code>
							</li>
							<li class="fragment">
								Git provides a shorthand <code>git rm file</code>
							</li>
						</ul>
					</section>

					<section>
						<h2>Checking changes (1)</h2>
						<ul>
							<li class="fragment">
								Use <code>git diff file</em></code> to compare the current state with the previously committed state
								<pre class="bigger fragment"><code class="shell" data-trim>
~/ikdoeict/git-demo on main
$ echo 'more hello' >> test.txt

~/ikdoeict/git-demo on main*
$ git diff test.txt
diff --git a/test.txt b/test.txt
index ce01362..3477282 100644
--- a/test.txt
+++ b/test.txt
@@ -1 +1,2 @@
hello
+more hello
</code></pre>
							</li>
						</ul>
					</section>


					<section>
						<h2>Checking the history (1)</h2>
						<ul>
							<li class="fragment">
								Use <code>git log</code> to see the commit log
								<pre class="bigger fragment"><code data-trim class="shell">
~/ikdoeict/git-demo
$ git log
commit c53f9b6bd0e7271af7c5d856f84f51d9b749d77f
Author: roelvs &lt;roelvs@bram.us&gt;
Date:   Tue Mar 19 22:09:32 2013 +0100

    Hello

commit 1d7a18481b5f6664d2cf30b1455c6ad1c041caa2
Author: roelvs &lt;roelvs@bram.us&gt;
Date:   Tue Mar 19 21:24:13 2013 +0100

    Deleted test2.txt

commit f1c68836b8c1f91c16d4f4c0540fca0f251ff946
Author: roelvs &lt;roelvs@bram.us&gt;
Date:   Tue Mar 19 20:44:31 2013 +0100

    Start tracking test2

commit 9c43f961b1defcc2f4f14526a2b20c4f3c267a62
Author: roelvs &lt;roelvs@bram.us&gt;
Date:   Tue Mar 19 16:02:03 2013 +0100

    Start tracking test.txt
</code></pre>
								<ul>
									<li class="fragment">Press <code>q</code> to exit the commit log</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Checking the history (2)</h2>
						<ul>
							<li class="fragment">
								Use <code>git log --oneline</code> to get a concise output
								<pre class="bigger fragment"><code class="shell" data-trim data-trim>
~/ikdoeict/git-demo
$ git log --oneline
c53f9b6 Hello
1d7a184 deleted test2.txt
f1c6883 Start tracking test2
9c43f96 Start tracking test.txt

~/ikdoeict/git-demo
$ 
</code></pre>
							</li>
							<li class="fragment">
								Filter commits by author
								<pre class="bigger fragment"><code class="shell">$ git log --author=name</code></pre>
							</li>
							<li class="fragment">
								Filter commits in time
								<pre class="bigger fragment"><code class="shell">$ git log --since=&quot;1 week ago&quot;</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Checking the history (3)</h2>
						<ul>
							<li class="fragment">
								Ultimate <code>git log</code>
								<pre class="bigger fragment"><code class="shell" style="white-space: nowrap; overflow: scroll;">$ git log --graph --pretty=format:'%Cred%h%Creset -%C(yellow)%d%Creset %s %Cgreen(%cr) %C(bold blue)&lt;%an&gt;%Creset' --abbrev-commit</code></pre>
								<pre class="bigger fragment"><code  class="shell" data-trim class="shell">
~/ikdoeict/git-demo
$ git log --graph --pretty=format:'%Cred%h%Creset -%C(yellow)%d%Creset %s %Cgreen(%cr) %C(bold blue)&lt;%an&gt;%Creset' --abbrev-commit
* c53f9b6 - (HEAD, main) Hello (16 minutes ago) &lt;roelvs&gt;
* 1d7a184 - Deleted test2.txt (61 minutes ago) &lt;roelvs&gt;
* f1c6883 - Start tracking test2 (2 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (6 hours ago) &lt;roelvs&gt;
</code></pre>
								<ul>
									<li class="fragment">
										Pro tip: create an alias <code>git lg</code> for it
										<pre class="bigger fragment"><code style="white-space: nowrap; overflow: scroll;">$ git config --global alias.lg "log --graph --pretty=format:'%Cred%h%Creset -%C(yellow)%d%Creset %s %Cgreen(%cr) %C(bold blue)&lt;%an&gt;%Creset' --abbrev-commit"</code></pre>
										<ul>
											<li class="fragment">From now on, use <code>git lg</code> to get the output as shown above</li>
										</ul>
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Git basics summary</h2>

						<ul>
							<li class="fragment text-16">
								Create repository
								<pre class="bigger fragment"><code class="shell">$ git init</code></pre>
							</li>
							<li class="fragment text-16">
								Stage file
								<pre class="fragment"><code class="shell">$ git add file</code></pre>
							</li>
							<li class="fragment text-16">
								Unstage file
								<pre class="bigger fragment"><code class="shell">$ git reset file</em></code></pre>
							</li>
							<li class="fragment text-16">
								Commit staged changes
								<pre class="bigger fragment"><code class="shell">$ git commit -m 'message'</code></pre>
							</li>
							<li class="fragment text-16">
								Check differences in a file (compared to repository)</em>
								<pre class="bigger fragment"><code class="shell">$ git diff file</em></code></pre>
							</li>
							<li class="fragment text-16">
								Check commit log (using our alias)</em>
								<pre class="bigger fragment"><code class="shell">$ git lg</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Git basics summary</h2>
						<p class="fragment" ><img src="assets/git/obama-not-bad.png" width="447" alt="" class="noborder" /></p>
					</section>

				</section>

				<section>
					<section>
						<h2>Remotes</h2>
						<p><img src="assets/git/futurama-zoidberg-entirely-scared.jpg" width="580" alt="" class="noborder" /><!-- Attack of the killer app S06E03 --></p>
						<q>Well, let's at least throw this TV away,<br />the batteries in the remote are gettin low.</q>
					</section>

					<section>
						<h2>Remotes</h2>

						<ul style="margin-bottom: 0;">
							<li class="fragment">
								A repository can be synched with a server
								<ul>
									<li class="fragment">In Git this is called a <strong>remote</strong></li>
									<li class="fragment">A remote is identified by a name, defaulting to <strong>origin</strong>, and a URL</li>
									<li class="fragment">Keep a local copy in sync with the remote by <strong>pushing</strong> and <strong>pulling</strong></li>
									<li class="fragment">Several users can push/pull to/from the same remote</li>
									<li class="fragment">Possible to define more than one remote (distributed)</em></li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Visualization
							</li>
						</ul>
						<figure class="fragment zoomable-15">
							<img src="assets/git/git-remote.png" width="800" alt="" class="noborder" /><br />
							<figcaption>Visual representation of a Git remote</figcaption>
						</figure>
					</section>

					<section>
						<h2>Setting up shop (1)</h2>

						<ul>
							<li class="fragment">
								If a local copy of a repository doesn't exist yet
								<ul>
									<li class="fragment">
										Clone the repository locally using <code>git clone url</em></code>
									</li>
									<li class="fragment">
										A local copy of the main + the entire commit history</em> is created
									</li>
								</ul>
								<pre class="bigger fragment"><code data-trim class="shell">
~/ikdoeict
$ git clone git@github.com:fabpot/Silex.git
Cloning into 'Silex'...
remote: Counting objects: 6612, done.
remote: Compressing objects: 100% (1908/1908), done.
remote: Total 6612 (delta 4225), reused 6317 (delta 4008)
Receiving objects: 100% (6612/6612), 1.28 MiB | 176 KiB/s, done.
Resolving deltas: 100% (4225/4225), done.

~/ikdoeict
$ cd Silex

~/ikdoeict/Silex on main
$ git log --oneline
59e7dbd merged branch davedevelopment/add-doc-info-to-docs (PR #647)
6a4fffe Added a note about writing documentation
8e6d30a merged branch davedevelopment/form-extension-points (PR #553)
7c38c9a Add services allowing for form type extensions and guessers
fd3ba62 merged branch GromNaN/remember-me (PR #645)
adc172b Add support for remember-me with RememberMeServiceProvider
fcd93b3 added a note about all possible options for the session (refs #633)
a31&hellip;
&hellip;
</code></pre>
								<ul>
									<li class="fragment">Clone a repo in the current directory using <code class="shell">git clone url</em> .</code></li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Setting up shop (2)</h2>

						<ul>
							<li class="fragment">
								If a local copy of a repository already exists
								<ul>
									<li class="fragment">
										Tell the repo where to find the remote: <code class="shell">git remote add name</em> url</em></code>
									</li>
									<li class="fragment">
										If the remote repository is empty, push your main to it
									</li>
								</ul>
								<pre class="bigger fragment"><code class="shell" data-trim>
~/ikdoeict/git-demo on main
$ git remote add origin git@github.com:roelvs/git-demo.git

~/ikdoeict/git-demo on main
$ git push origin main
Counting objects: 9, done.
Delta compression using up to 8 threads.
Compressing objects: 100% (5/5), done.
Writing objects: 100% (9/9), 705 bytes, done.
Total 9 (delta 1), reused 0 (delta 0)
To git@github.com:roelvs/git-demo.git
 * [new branch]      main -> main

~/ikdoeict/git-demo on main
$ </code></pre>
								<ul>
									<li class="fragment">
										If the remote repository is not empty &hellip; (see further)</em>
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Push &amp; Pull</h2>
						<ul>
							<li class="fragment">
								Publish locally committed changes
								<pre class="bigger"><code class="shell">$ git push origin main</code></pre>
								<ul class="fragment">
									<li>Use <code>git push</code> and it'll default to <code>origin</code> and <code>main</code></li>
								</ul>
							</li>
							<li class="fragment">
								Pull changes from the server
								<pre class="bigger"><code class="shell">$ git pull</code></pre>
								<ul class="fragment">
									<li>
										Will fetch the changes of the tracked branch</em> and merge them into the locally active branch</em>
										<ul>
											<li>In this example: <code>origin/main</code> &rarr; <code>main</code></li>
										</ul>
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Inspecting remotes</h2>
						<ul>
							<li class="fragment">
								List all remotes
								<pre class="bigger fragment"><code class="shell">~/ikdoeict/git-demo on main
$ git remote show
origin</code></pre>
							</li>
							<li class="fragment">
								Inspect one remote
								<pre class="bigger fragment"><code class="shell" data-trim>~/ikdoeict/git-demo on main
$ git remote show origin
* remote origin
  Fetch URL: git@github.com:roelvs/git-demo.git
  Push  URL: git@github.com:roelvs/git-demo.git
  HEAD branch: main
  Remote branch:
    main tracked
  Local ref configured for 'git push':
    main pushes to main (up to date)</code></pre>
							</li>
						</ul>
					</section>
				</section>

				<section>
					<section>
						<h2>Branching</h2>
						<p style="margin-top: 1.2em;"><img src="assets/git/bttf2-timeline.jpg" width="580" alt="" class="noborder" /></p>
						<q>Imagine that this line represents time. At some point in the past, the timeline skewed into this tangent creating an alternate 1985.</q>
					</section>

					<section>
						<h2>Branches</h2>

						<ul >
							<li class="fragment text-16 " >
								The default branch is <code>main</code>
							</li>
							<li class="fragment text-16" style="margin-top: 0.5em;">
								List all branches
								<pre class="bigger"><code class="shell">$ git branch</code></pre>
							</li>
							<li class="fragment text-16" style="margin-top: 0.5em;">
								Create other branches to develop experimental features
								<pre class="bigger"><code class="shell">$ git branch experimental</code></pre>
								<ul>
									<li>Branches are created locally</li>
								</ul>
							</li>
							<li class="fragment text-16" style="margin-top: 0.5em;">
								Activate (checkout)</em> a branch
								<pre class="bigger"><code class="shell">$ git checkout experimental</code></pre>
								<ul>
									<li>The <code>head</code> will be moved to the new branch</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Branching off</h2>

						<ul>
							<li class="fragment">
								Creating an <code>experiment</code> branch based on the <code>main</code>
								<pre class="bigger fragment"><code class="shell" data-trim data-line-numbers="1-3|5-6|8-11|13-15|17-20" ">
									
~/ikdoeict/git-demo on main
$ git branch
* main

~/ikdoeict/git-demo on main
$ git branch experiment

~/ikdoeict/git-demo on main
$ git branch
  experiment
* main

~/ikdoeict/git-demo on main
$ git checkout experiment
Switched to branch 'experiment'

~/ikdoeict/git-demo on experiment
$ git branch
* experiment
  main
</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Visualization</h2>
						<figure class="fragment zoomable-15">
							<img src="assets/git/git-branching-1.png" width="450" alt="" class="noborder" /><br />
							<img src="assets/git/git-branching-2.png" width="450" alt="" class="noborder" /><br />
							<img src="assets/git/git-branching-3.png" width="450" alt="" class="noborder" />
							<figcaption>Visual representation of creating and switching to a branch</figcaption>
						</figure>
					</section>

					<section>
						<h2>Committing changes</h2>
						<ul>
							<li class="fragment">
								Changes are committed on the active branch
								<pre class="bigger fragment"><code data-trim class="shell" >
~/ikdoeict/git-demo on experiment
$ touch exp.txt

~/ikdoeict/git-demo on experiment*
$ git add .

~/ikdoeict/git-demo on experiment*
$ git commit -m 'Start tracking exp.txt'
[experiment a65b9d7] Start tracking exp.txt
 0 files changed
 create mode 100644 exp.txt

~/ikdoeict/git-demo on experiment
$ git lg
* a65b9d7 - (HEAD, experiment) Start tracking exp.txt (7 seconds ago) &lt;roelvs&gt;
* c53f9b6 - (origin/main, main) Hello (15 hours ago) &lt;roelvs&gt;
* 1d7a184 - Deleted test2.txt (16 hours ago) &lt;roelvs&gt;
* f1c6883 - Start tracking test2 (17 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (22 hours ago) &lt;roelvs&gt;

~/ikdoeict/git-demo on experiment
$ git checkout main
Switched to branch 'main'

~/ikdoeict/git-demo on main
$ ls
drwxr-xr-x   4 roelvs  staff  136 Mar 20 20:19 .
drwxr-xr-x  11 roelvs  staff  374 Mar 20 15:53 ..
drwxr-xr-x  14 roelvs  staff  476 Mar 20 20:19 .git
-rw-r--r--   1 roelvs  staff    6 Mar 20 14:38 test.txt

~/ikdoeict/git-demo on main
$ echo 'on the main right now' &gt;&gt; test.txt

~/ikdoeict/git-demo on main*
$ git add .

~/ikdoeict/git-demo on main*
$ git commit -m 'on the main'
[main 0ea8dd4] on the main
 1 file changed, 1 insertion(+)

~/ikdoeict/git-demo on main
$ git lg
* 0ea8dd4 - (HEAD, main) on the main (2 seconds ago) &lt;roelvs&gt;
* c53f9b6 - (origin/main) Hello (15 hours ago) &lt;roelvs&gt;
* 1d7a184 - Deleted test2.txt (16 hours ago) &lt;roelvs&gt;
* f1c6883 - Start tracking test2 (17 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (22 hours ago) &lt;roelvs&gt;
</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Visualization</h2>
						<figure class="fragment zoomable-20">
							<img src="assets/git/git-branch-1-commitexp.png" width="300" alt="" class="noborder" /><br />
							<img src="assets/git/git-branch-2-switch.png" width="300" alt="" class="noborder" /><br />
							<img src="assets/git/git-branch-3-commitmaster.png" width="300" alt="" class="noborder" />
							<figcaption>Visual representation of committing on different branches</figcaption>
						</figure>
					</section>

					<section>
						<h2>Merging changes</h2>
						<ul>
							<li class="fragment">
								Include changes from an other branch with <code>git merge</code>
								<ul>
									<li>
										Changes made <code>otherbranch</code> are <strong>merged</strong> into the <code>HEAD</code>
										<ul>
											<li>Three way merge between common ancestor and two last branch snapshots</li>
										</ul>
									</li>
									<li>A merge commit is created</li>
								</ul>
								<pre class="bigger fragment"><code class="shell" data-trim >
~/ikdoeict/git-demo on main
$ git merge experiment
Merge made by the 'recursive' strategy.
 0 files changed
 create mode 100644 exp.txt

~/ikdoeict/git-demo on main
$ git lg
*   965d016 - (HEAD, main) Merge branch 'experiment' (5 seconds ago) &lt;roelvs&gt;
|\
| * a65b9d7 - (experiment) Start tracking exp.txt (6 minutes ago) &lt;roelvs&gt;
* | 0ea8dd4 - on the main (2 minutes ago) &lt;roelvs&gt;
|/
* c53f9b6 - (origin/main) Hello (22 hours ago) &lt;roelvs&gt;
* 1d7a184 - Deleted test2.txt (23 hours ago) &lt;roelvs&gt;
* f1c6883 - Start tracking test2 (24 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (28 hours ago) &lt;roelvs&gt;
</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Visualization</h2>
						<figure>
							<img src="assets/git/git-merge.png" width="700" alt="" class="noborder" /><br />
							<figcaption>Visual representation of merging changes</figcaption>
						</figure>
					</section>

					<section>
						<h2>Cleaning up</h2>
						<ul>
							<li class="fragment">
								Delete branches you don't need anymore
								<pre><code class="bigger shell">$ git branch -d branchname</em></code></pre>
								<ul class="fragment">
									<li>If a branch hasn't been merged yet, Git will warn you</li>
									<li>Override warning using <code>-D</code> instead of <code>-d</code></li>
								</ul>
								<pre class="bigger fragment"><code class="shell" data-trim>
~/ikdoeict/git-demo on main
$ git branch -d otherbranch
error: The branch 'otherbranch' is not fully merged.
If you are sure you want to delete it, run 'git branch -D otherbranch'.

~/ikdoeict/git-demo on main
$ git branch -D otherbranch
Deleted branch otherbranch (was e079840).
</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Handling Conflicts</h2>

						<div class="fragment">
							<p ><img src="assets/git/barfing-rainbow.gif" width="600" alt="" class="noborder" /></p>

							<p>Hold tight!</p>
						</div>

					</section>

					<section>
						<h2>Handling conflicts (1)</h2>
						<ul>
							<li class="fragment">
								When merging, things can go wrong
								<ul>
									<li>e.g. the same line of code has been edited</li>
									<li>When a <strong>merge conflict</strong> occurs, the merge will pause</li>
									<li>Manual intervention (choosing which version to keep)</em> is needed</li>
								</ul>
								<pre class="bigger fragment"><code data-trim class="shell" >
~/ikdoeict/git-demo on main
$ echo 'something for exp' >> exp.txt

~/ikdoeict/git-demo on main*
$ git add .

~/ikdoeict/git-demo on main*
$ git commit -m 'change exp.txt'
[main babbcd3] change exp.txt
 1 file changed, 1 insertion(+)

~/ikdoeict/git-demo on main
$ git checkout experiment 
Switched to branch 'experiment'

~/ikdoeict/git-demo on experiment
$ echo 'a different line for exp.txt' >> exp.txt

~/ikdoeict/git-demo on experiment*
$ git add .

~/ikdoeict/git-demo on experiment*
$ git commit -m 'change exp.txt (from experiment)'
[experiment 2925064] change exp.txt (from experiment)
 1 file changed, 1 insertion(+)

~/ikdoeict/git-demo on experiment
$ git checkout main
Switched to branch 'main'

~/ikdoeict/git-demo on main
$ git merge experiment
Auto-merging exp.txt
CONFLICT (content): Merge conflict in exp.txt
Automatic merge failed; fix conflicts and then commit the result.

~/ikdoeict/git-demo on main*
$ git status
# On branch main
# Unmerged paths:
#   (use &quot;git add/rm &lt;file&gt;...&quot; as appropriate to mark resolution)
#
#	both modified:      exp.txt
#

~/ikdoeict/git-demo on main*
$ cat exp.txt 
&lt;&lt;&lt;&lt;&lt;&lt;&lt; HEAD
something for exp
=======
a different line for exp.txt
&gt;&gt;&gt;&gt;&gt;&gt;&gt; experiment

~/ikdoeict/git-demo on main*
$ vim exp.txt

~/ikdoeict/git-demo on main*
$ git add exp.txt

~/ikdoeict/git-demo on main*
$ git commit
[main 80de07c] Merge branch 'experiment'

~/ikdoeict/git-demo on main
$ </code></pre>
								<ul class="fragment">
									<li>&rarr; Fix the conflict, stage the file and commit</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Handling conflicts (2)</h2>
						<ul>
							<li class="fragment">
								Conflicted file contents
								<pre class="bigger"><code data-trim class="shell">
&lt;&lt;&lt;&lt;&lt;&lt;&lt; HEAD
something for exp
=======
a different line for exp.txt
&gt;&gt;&gt;&gt;&gt;&gt;&gt; experiment</code></pre>
								<ul>
									<li class="fragment">
										Resolve manually in a text editor
									</li>
									<li class="fragment">
										Choose version from <code>HEAD</code>
										<pre class="bigger"><code class="shell">$ git checkout --ours conflictedfile</em></code></pre>
									</li>
									<li class="fragment">
										Choose version from <code>otherbranch</code>
										<pre class="bigger"><code class="shell">$ git checkout --theirs conflictedfile</em></code></pre>
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Rebasing (1)</h2>
						<ul>
							<li class="fragment">
								Next to merging one can also <strong>rebase</strong>
							</li>
							<li class="fragment" style="margin-top: 1em">
								No three way merge but
								<ol>
									<li>Rewinds to the common ancestor</li>
									<li>Forwards to the last commit of the branch</li>
									<li>Applies the commits of the current branch on top of that state</li>
									<li>That final state is saved as the original branch</li>
								</ol>
							</li>
							<li class="fragment" style="margin-top: 1em">
								Roughly translated: inject the changes made on another branch into your branch to stay up-to-date.
							</li>
						</ul>
					</section>

					<section>
						<h2>Rebasing (3)</h2>
						<ul>
							<li class="fragment">
								Rule #1 of rebasing
								<ul>
									<li class="fragment">Don't rebase onto a branch that is shared with others</li>
									<li class="fragment">Put differently: only rebase on local featurebranches</li>
									<li class="fragment">Put differently, again: <strong>don't ever rebase onto your main</strong></li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Rebase often to prevent potential merge conflicts
							</li>
							<li class="fragment" style="margin-top: 1em;">
								If the <code>featurebranch</code> is completed, merge it into the <code>main</code>
							</li>
						</ul>
					</section>

					<section>
						<h2>Rebasing Example</h2>

						<pre class="bigger fragment"><code class="bash" data-trim>
~/ikdoeict/git-demo on main
$ git lg
* 1e7f02e - (HEAD, main) A change comtd on main (12 seconds ago) &lt;roelvs&gt;
* 80de07c - First commit! (2 minutes ago) &lt;roelvs&gt;

~/ikdoeict/git-demo on main
$ git checkout experiment
Switched to branch 'experiment'

~/ikdoeict/git-demo on experiment
$ git lg
* 669ae62 - (HEAD, experiment) A 2nd change comtd on experiment (34 seconds ago) &lt;roelvs&gt;* a9bdacb - A change comtd on experiment(69 seconds ago) &lt;roelvs&gt;
* 80de07c - First commit! (2 minutes ago) &lt;roelvs&gt;

~/ikdoeict/git-demo on experiment
$ git rebase main
First, rewinding head to replay your work on top of it...
Applying: A change comtd on experiment
Applying: A 2nd change comtd on experiment

~/ikdoeict/git-demo on experiment
$ git lg
* dba0673 - (HEAD, experiment) A 2nd change comtd on experiment (2 seconds ago) &lt;roelvs&gt;* 84484e4 - A change comtd on experiment(2 seconds ago) &lt;roelvs&gt;
* 1e7f02e - (main) A change comtd on main (54 seconds ago) &lt;roelvs&gt;
* 80de07c - First commit! (3 minutes ago) &lt;roelvs&gt;
</code></pre>
							<p class="fragment">Note: New commit hashes are generated as the patches are applied on top of the rewind/ffwd!</em></p>
					</section>

					<section>
						<h2>Visualization</h2>
						<figure class="fragment zoomable-15">
							<img src="assets/git/git-rebase-1.png" width="550" alt="" class="noborder" /><br />
							<img src="assets/git/git-rebase-2.png" width="550" alt="" class="noborder" />
							<figcaption>Visual representation of <code>git rebase</code></figcaption>
						</figure>
					</section>

					<section>
						<h2>Visualization bis</h2>
						<figure class="fragment zoomable-15" style="margin-top: 2em;">
							<img src="assets/git/git-rebase.png" width="800" alt="" class="noborder" />
							<figcaption>Alternate visual representation of <code>git rebase</code></figcaption>
						</figure>
					</section>

					<section>
						<h2>Rebase conflicts</h2>
						<ul>
							<li class="fragment">
								About the same scenario as when a merge conflict</em> happens
								<ul>
									<li class="fragment">Fix the conflict manually</li>
									<li class="fragment">
										Add the fixed file
										<pre class="bigger"><code class="shell">$ git add conflictedfile</em></code></pre>
									</li>
									<li class="fragment">
										Continue the rebase
										<pre class="bigger"><code class="shell">$ git rebase --continue</code></pre>
										<ul>
											<li>
												Aborting the rebase is also possible
												<pre class="bigger"><code class="shell">$ git rebase --abort</code></pre>
											</li>
										</ul>
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Publishing/Pulling branches</h2>
						<ul>
							<li class="fragment">
								Publish a branch
								<pre class="bigger"><code class="shell">$ git push origin localbranch</em>:remotebranch</em></code></pre>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Delete a remote branch
								<pre class="bigger"><code class="shell">$ git push origin :remotebranch</em></code></pre>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Create local branch based on remote branch
								<pre class="bigger"><code class="shell">$ git checkout -b localbranch</em> remote/remotebranch</em></code></pre>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Update remote branch list
								<pre class="bigger"><code class="shell">$ git remote update</code></pre>
							</li>
						</ul>
					</section>

				</section>

				<section>
					<section>
						<h2>Collaboration</h2>
						<p><img src="assets/git/futurama-bender-fight.jpg" width="600" alt="" class="noborder" /></p>
						<q>Yes, we have to work together, and not<br />have this fight I was definitely winning.</q>
					</section>
					<section>
						<h2>Collaboration</h2>

						<ul>
							<li class="fragment">Knowing how to branch != knowing how to collaborate</li>
							<li class="fragment">
								When collaborating, maintain this flow
								<pre class="bigger"><code class="shell" data-trim >

# 1. Make sure the main is up-to-date
$ git checkout main
     $ git pull

# 2. Create a featurebranch based on the main
$ git checkout -b featurebranch

# 3. Develop, stage, and commit your feature on the featurebranch.
     When finished continue to step 4

# 4. Make sure the main is still up-to-date
$ git checkout main
     $ git pull

# 5. Rebase the main onto the featurebranch
     (skip this step if main remained unchanged since step 1)
$ git checkout featurebranch
     $ git rebase main

# 6. Merge the featurebranch onto the main
$ git checkout main
     $ git merge featurebranch

# 7. Push the main
$ git push origin main

# 8. Clean up
$ git branch -d featurebranch

# 9. Rinse. Repeat</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Few pointers</h2>

						<ul>
							<li class="fragment">
								Don't ever develop on the <code>main</code>, but on featurebranches</em>
								<ul>
									<li class="fragment">In case that happens use <code>git pull --rebase</code> to minimize the situation and keep the main clean (<a href="http://cdn.kentnguyen.com/wp-content/uploads/2012/01/git_rebase.png">#</a>). From then on create a featurebranch and continue</li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">The <code>main</code> must at all times contain deployable code </li>
							<li class="fragment" style="margin-top: 1em;">Keep your featurebranches local</li>
						</ul>
					</section>

					<section>
						<h2>Undoing commits</h2>

						<ul>
							<li class="fragment">
								Undo last commit
								<pre class="bigger"><code class="shell">$ git revert HEAD~1</code></pre>
								<ul>
									<li class="fragment">Creates a new undo commit</em> &rarr; the faulty commit will always be accessible by checking out that commithash!</li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Possible to undo a commit without keeping it in the history <strong>only if it hasn't been pushed yet</strong> (two methods)</em>
								<pre class="bigger"><code class="shell">$ git rebase -i commithash</code></pre>
								<pre class="bigger"><code class="shell">$ git rebase -i HEAD~2</code></pre>
								<ul>
									<li class="fragment">Alternatively checkout the commithash before the faulty one and branch off</li>
								</ul>
							</li>
						</ul>
					</section>

				</section>

				<section>
					<section>
						<h2 style="visibility: hidden;">GitHub</h2>
						<p style="margin-top: 1.5em;"><img src="assets/git/github.png" width="800" alt="" class="noborder" /></p>
					</section>

					<section>
						<h2 style="visibility: hidden;">Gitlab</h2>

						<figure><img src="assets/git/GitLab_logo.svg" alt="" title="" width="700" class="noborder" /></figure>

					</section>

					<section>
						<h2>GitHub and Gitlab are &hellip;</h2>

						<ol>
							<li class="fragment">
								A website to browse Git repos
								<ul>
									<li>Browse branches</li>
									<li>Inspect commmits (<a href="https://github.com/roelvs/ws2-sws-course-materials/commit/01a54d00633ca8627c717bdec442d322e45e67e8">example</a>)</li>
									<li>Issues</li>
									<li>Pull Requests</li>
									<li>&hellip;</li>
								</ul>
							</li>
							
						</ol>
					</section>

					<section>
						<h2>Github and Gitlab are &hellip;</h2>
						<ol start="3">
							<li class="fragment">
								A remote to push your repositories to
								<ul>
									<li>Public / Private (paid account)</li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Embraced by the open-source community
							</li>
						</ol>
						<div class="fragment warning" style="margin-top: 2em"><p>PLEASE NOTE: GITHUB/GITLAB IS NOT GIT!</p></div>
						<div class="fragment warning" style="margin-top: 0.5em"><p>AGAIN: GITHUB/GITLAB IS NOT GIT!</p></div>
					</section>

					<section>
						<h2>Forking</h2>

						<blockquote class="fragment" style="margin-top: 1em;">If you don't like my code, Fork off!</blockquote>

						<ul>
							<li class="fragment" style="margin-top: 1em;">
								Clone a repo from one github account to an other one
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Create forks to develop your own features/your own version of the project
								<ul>
									<li class="fragment">Develop on a local <code>featurebranch</code></li>
									<li class="fragment">Publish <code>featurebranch</code> when ready to your own GitHub remote</li>
									<li class="fragment">Do a <a href="https://help.github.com/articles/using-pull-requests">pull request</a> to see your changes implemented in the original project repo</li>
								</ul>
							</li>
						</ul>
					</section>
					<section>
						<h2>Why forking?</h2>
						<ul>
								<figure><img src="assets/git/git-llama-forks.png" alt="" title="" width="700" class="noborder" /></figure>
								<ul>
									<li class="fragment">Traditional workflow in open source projects.</li>
									<li class="fragment">Everyone can create an alternative version</li>
									<li class="fragment">The original author remains in charge of the base repo.</li>
								</ul>
							
						</ul>
					</section>

					<section>
						<h2>Forking Flow (GitHub)</h2>

						<pre><code  class="shell" data-trim>
# 1. Create a fork on GitHub
e.g. clone fabpot/Silex to roelvs/Silex

# 2. Clone your repo locally
$ git clone git@github.com:roelvs/Silex.git

# 3. Create a featurebranch based on the main
$ git checkout -b featurebranch

# 4. Develop, stage, and commit your feature on the featurebranch.
When finished continue to step 5

# 5. Publish your featurebranch on GitHub
$ git push origin localbranch remotebranch

# 6. Do a pull request via GitHub and await merging

# 7. Rinse. Repeat.
Make sure your main is in sync with the original main one!
     (add the original repo as remote and `git fetch` and `git rebase original/main`)
</code></pre>
     						<p class="fragment">Or, alternatively, <a href="https://help.github.com/articles/using-pull-requests/#sending-the-pull-request">do it via the Github website</a> ;-)</em></p>
					</section>

					<section>
						<h2>Merging Pull Requests</h2>
						<pre class="bigger fragment"><code class="shell" data-trim># 1. Checkout your main branch
$ git checkout main

# 2. Add a new remote named 'otherdude'
$ git remote add otherdude git://github.com/otherdude/Project.git

# 3. Fetch information about all branches on the 'otherdude' remote
$ git fetch otherdude

# 4. Merge 'otherdude/featurebranch' into your main
$ git merge otherdude/featurebranch

# 5. Push your newly-merged branch back to GitHub
$ git push origin main</code></pre>
     					<p class="fragment">Or, alternatively, <a href="https://help.github.com/articles/merging-a-pull-request/">do it via the GitHub website</a> ;-)</em></p>
					</section>

					<section>
						<h2>Git workflows: Github flow</h2>
						<ul>
								<figure><img src="assets/git/github-flow.png" alt="" title="" width="700" class="noborder" /></figure>
								<ul>
									<li class="fragment">Simples of all git flows.</li>
									<li class="fragment">One central branch, many feature-branches</li>
							
								</ul>
							
						</ul>
					</section>
					<section>
						<h2>Git workflows: Gitlab flow</h2>
						<ul>
								<figure><img src="assets/git/gitlab-flow.png" alt="" title="" width="700" class="noborder" /></figure>
								<ul>
									<li class="fragment">Branches per environment (production, staging, ...).</li>
									
								</ul>
							
						</ul>
					</section>
					<section>
						<h2>Git workflows: Gitflow</h2>
						<ul>
								<figure><img src="assets/git/git-flow.png" alt="" title="" width="700" class="noborder" /></figure>
								<ul>
									<li class="fragment">Workflow for complex projects and fixed versions.</li>

									<li class="fragment">(too?) much overhead for smaller projects</li>
								</ul>
							
						</ul>
					</section>

				</section>

				<section>
					<section>
						<h2>Don't lose your HEAD!</h2>
						<p style="margin-top: 1.2em;"><img src="assets/git/futurama-head-museum.jpg" width="500" alt="" class="noborder" /></p>
						<q>Welcome to the Head Museum. I'm Leonard Nimoy.</q>
					</section>

					

					<section>
						<h2>HEAD</h2>
						<ul>
							<li class="fragment">
								The <strong>HEAD</strong> is a pointer pointing towards the currently checked out <em style="font-size: 75%">(= active)</em> <strong>revision</strong> <em style="font-size: 75%">(= commit)</em>
							</li>
						</ul>
						<figure class="fragment">
							<img src="assets/git/git-timeline-master-head.png" alt="" title="" width="700" />
						</figure>
					</section>

					<section>
						<h2>Moving the HEAD</h2>
						<ul>
							<li class="fragment">
								The <strong>HEAD</strong> can be moved by <strong>checking out</strong> a revision</em>
								<pre class="bigger fragment"><code data-trim class="shell">
~/ikdoeict/git-demo on main
$ git lg
* c53f9b6 - (HEAD, main) Hello (15 hours ago) &lt;roelvs&gt;
* 1d7a184 - Deleted test2.txt (16 hours ago) &lt;roelvs&gt;
* f1c6883 - Start tracking test2 (17 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (22 hours ago) &lt;roelvs&gt;

~/ikdoeict/git-demo on main
$ git checkout 1d7a184
Note: checking out '1d7a184'.

You are in 'detached HEAD' state. You can look around, make experimental
changes and commit them, and you can discard any commits you make in this
state without impacting any branches by performing another checkout.

HEAD is now at 1d7a184... Deleted test2.txt

~/ikdoeict/git-demo on (no branch)
$ git lg
* 1d7a184 - (HEAD) Deleted test2.txt (16 hours ago) &lt;roelvs&gt;
* f1c6883 - Start tracking test2 (17 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (22 hours ago) &lt;roelvs&gt;

~/ikdoeict/git-demo on main
$ git checkout f1c6883
Previous HEAD position was 1d7a184... Deleted test2.txt
HEAD is now at f1c6883... Start tracking test2

~/ikdoeict/git-demo on (no branch)
$ git lg
* f1c6883 - (HEAD) Start tracking test2 (17 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (22 hours ago) &lt;roelvs&gt;

~/ikdoeict/git-demo on main
$  git checkout main
Previous HEAD position was f1c6883... Start tracking test2
Switched to branch 'main'

~/ikdoeict/git-demo on main
$ git lg
* c53f9b6 - (HEAD, main) Hello (15 hours ago) &lt;roelvs&gt;
* 1d7a184 - Deleted test2.txt (16 hours ago) &lt;roelvs&gt;
* f1c6883 - Start tracking test2 (17 hours ago) &lt;roelvs&gt;
* 9c43f96 - Start tracking test.txt (22 hours ago) &lt;roelvs&gt;

~/ikdoeict/git-demo on main
$ </code></pre>
								<ul>
									<li class="fragment">
										When checking out a revision the files in your working directory change to the state of the selected revision
									</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Visualization</h2>
						<figure class="fragment zoomable-15">
							<img src="assets/git/git-movinghead-1.png" width="450" alt="" class="noborder" /><br />
							<img src="assets/git/git-movinghead-2.png" width="450" alt="" class="noborder" /><br />
							<img src="assets/git/git-movinghead-3.png" width="450" alt="" class="noborder" />
							<figcaption>Visual representation of moving the <code>HEAD</code> using <code>git checkout</code></figcaption>
						</figure>
					</section>

					<section>
						<h2>Unstaging revisited</h2>

						<ul>
							<li class="fragment">
								Unstage one file
								<pre ><code class="shell">$ git reset filename</code></pre>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								Unstage all files
								<pre class="bigger"><code class="shell">$ git reset HEAD</code></pre>
							</li>
						</ul>
					</section>

					<section>
						<h2>Discarding changes</h2>

						<ul>
							<li class="fragment text-16">
								Unstaged changes can be discarded
								<pre class="bigger"><code class="shell">$ git checkout -- filename</em></code></pre>
								<ul class="fragment">
									<li>The selected file will go back to the last committed state</li>
								</ul>
							</li>
							<li class="fragment text-16" style="margin-top: 0.5em;">
								Unstage all + discard all changes
								<pre class="bigger"><code class="shell">$ git reset HEAD --hard</code></pre>
								<ul>
									<li class="fragment">The entire working directory</em> will go back to the last committed state</li>
									<li class="fragment">Cannot be undone (!!)</li>
								</ul>
							</li>
							<li class="fragment text-16" style="margin-top: 0.5em;">
								Unstage all + stash all changes
								<pre class="bigger"><code class="shell">$ git stash</code></pre>
								<ul>
									<li class="fragment">The entire working directory</em> will go back to the last committed state</li>
									<li class="fragment">Can be undone as the state is saved in a <strong>stash</strong> <small><a href="http://git-scm.com/book/en/Git-Tools-Stashing">&#9873;</a></small></li>
								</ul>
							</li>
						</ul>
					</section>
				</section>

				<section>
					<section>
						<h2>A few more things</h2>
						<p><img src="assets/git/futurama-mutant-march.png" width="600" alt="" class="noborder" /></p>
						<q>Let's go. If I say one more thing,<br />I might say it with my evening boot.</q>
					</section>

					<section>
						<h2>Git Ignore File</h2>

						<ul>
							<li class="fragment">
								Git will track all files in the working directory for changes
							</li>
							<li class="fragment" style="margin-top: 1em">
								Ignore certain files by placing their name in <code>.gitignore</code>
								<code data-trim>
Thumbs.db
app.db
*.log
vendor/*
node_modules/*
config.php</code>
							</li>
							<li class="fragment" style="margin-top: 1em">
								<code>.gitignore</code> must be committed into the repository
							</li>
						</ul>
					</section>

					<section>
						<h2>Config files</h2>

						<ul>
							<li class="fragment">
								Don't commit config files such as <code>config.php</code>
							</li>
							<li class="fragment" style="margin-top: 1em">
								Add <code>config.php</code> to <code>.gitignore</code> and provide a <code>config.sample.php</code> instead
							</li>
						</ul>
						<p class="fragment">Don't believe me? Check <a href="https://www.comparitech.com/blog/information-security/github-honeypot//">Leaked credentials on GitHub</a>.</em></p>
					</section>

					<section>
						<h2>Partially staging files</h2>

						<ul>
							<li class="fragment">
								Commits must contain only one set of changes
							</li>
							<li class="fragment">
								In case of several changes, choose which changes may be staged in <a href="http://git-scm.com/book/en/v2/Git-Tools-Interactive-Staging#Staging-Patches">Patch Mode</a> using <code>git add -p file</code>
							</li>
						</ul>
						<pre class="bigger fragment"><code class="shell" data-trim>
~/ikdoeict/ikdoeict-website on main*
$ git add -p index.html
diff --git a/index.html b/index.html
index 3fc8413..d7af84e 100644
--- a/index.html
+++ b/index.html
@@ -1,6 +1,6 @@
 &lt;!DOCTYPE html&gt;
 &lt;head>
-	&lt;title&gt;Home | Ikdoeict.BE&lt;/title&gt;
+	&lt;title&gt;Home | IkdoeICT.BE&lt;/title&gt;
 	&lt;meta charset="utf-8" /&gt;
 	&lt;link rel="stylesheet" href="css/normalize.css" /&gt;
Stage this hunk [y,n,q,a,d,/,j,J,g,e,?]? y

@@ -176,7 +176,7 @@
     &lt;/section&gt;
     &lt;footer&gt;
-	&lt;p&gt;Copyright (c) 2021 IkdoeICT.be&lt;/p&gt;
+	&lt;p&gt;Copyright (c) 2022 IkdoeICT.be&lt;/p&gt;
     &lt;/footer&gt;
 &lt;/div&gt;
 Stage this hunk [y,n,q,a,d,/,j,J,g,e,?]? n

~/ikdoeict/ikdoeict-website on main*
$ git status
# On branch main
# Changes to be committed:
#   (use &quot;git reset HEAD &lt;file&gt;...&quot; to unstage)
#
#	modified:   index.html
#
# Changes not staged for commit:
#   (use &quot;git add &lt;file&gt;...&quot; to update what will be committed)
#   (use &quot;git checkout -- &lt;file&gt;...&quot; to discard changes in working directory)
#
#	modified:   index.html
#

~/ikdoeict/ikdoeict-website on main*
$ git commit -m 'title casing'
[main fc91e11] title casing
 1 file changed, 1 insertion(+), 1 deletion(-)

~/ikdoeict/ikdoeict-website on main*
$ git diff index.html
diff --git a/index.html b/index.html
index 7602651..d7af84e 100644
--- a/index.html
+++ b/index.html
@@ -176,7 +176,7 @@
     &lt;/section&gt;
     &lt;footer&gt;
-	&lt;p&gt;Copyright (c) 2021 IkdoeICT.be&lt;/p&gt;
+	&lt;p&gt;Copyright (c) 2022 IkdoeICT.be&lt;/p&gt;
     &lt;/footer&gt;
 &lt;/div&gt;

~/ikdoeict/ikdoeict-website on main*
$ git add .

~/ikdoeict/ikdoeict-website on main*
$ git commit -m 'copyright 2022 instead of 2021'
[main c36c7be] copyright 2022 instead of 2021
 1 file changed, 1 insertion(+), 1 deletion(-)
</code></pre>
					</section>

					

					<section>
						<h2>Practice!</h2>

						<ul>
							<li class="fragment">
								I learned Git by just going for it. You should too.
								<ul>
									<li>
										Create a local Git repo for your next project
									</li>
									<li>
										Use some of the online courses/tools
										<ul>
											<li><a href="http://try.github.com/">Codeshool: Try Git</a></li>
											<li><a href="http://pcottle.github.com/learnGitBranching/?NODEMO">Learn Git Branching</a> (Definitely try out merging and rebasing!)</em></li>
										</ul>
									</li>
									</li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em">
								I stil have much to learn about Git
								<ul>
									<li>&hellip; but I know how to Google when in need</li>
									<li>&hellip; but I know how to read (<a href="http://git-scm.com/book/en/">a free book on Git</a>)</li>
								</ul>
							</li>
						</ul>
					</section>

					<section>
						<h2>Want more?!</h2>

						<ul class="fragment">
							<li>
								Stashing
							</li>
							<li>
								Tagging
							</li>
							<li>
								Cherry Picking
							</li>
							<li>
								Continuous Integration
							</li>
							<li>
								Commit hooks
							</li>
							<li>
								&hellip;
							</li>
						</ul>
					</section>

				</section>

				<!-- The END -->
				<section>
					<section>
						<h2>Questions?</h2>

						<p style="margin-top: 5.5em; opacity: 0.35;">(Press &darr; to see some frequently asked ones)</em></p>


					</section>

					<section>
						<h2 >Why not just use Onedrive?</h2>
						<ul>
							<li class="fragment">Yes, your files will be synced</li>
							<li class="fragment">
								But &hellip;
								<ul class="fragment">
									<li>No proper collaboration (changes can be overwritten by others)</em></li>
									<li>No all-of-the-time deployable code (mid development you cannot deploy your code)</em></li>
									<li>No experimental features (you cannot start an experiment on a separate branch)</em></li>
									<li>No author information (who broke what?)</em></li>
									<li>No going back in time (limited to a few days in Dropbox)</em></li>
									<li>No proper timeline (what, you're gonna zip up your files per feature developed? &rarr; That's versioning!)</em></li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								And oh: don't ever share a folder that is a git repo
							</li>
						</ul>
					</section>

					<section>
						<h2>Do I have to remember all those commands?</h2>

						<ul>
							<li class="fragment">No, sometimes I have to lookup one too.<br />That's perfectly fine.</li>
							<li class="fragment" style="margin-top: 1em;">It's allowed to use a GUI but you should have a (vague) idea of what is happening in the background</li>
							<li class="fragment" style="margin-top: 1em;">Know the basic concepts (stage, commit, push, pull, merge, rebase)</li>
						</ul>
					</section>

					<section>
						<h2>I'll be fine without Git, right?</h2>

						<ul>
							<li class="fragment">
								Alas, no dice. Whether you like it or not you'll have to use Git if you're ever going to do something in software/web
								<ul>
									<li>Above that it's a requirement for some of our courses</li>
								</ul>
							</li>
							<li class="fragment" style="margin-top: 1em;">
								We know it's tough, but hang on until you get the gist of it
								<ul>
									<li>There's memory in repetition. There's memory in repetition</li>
									<li>Truth be told, it took me over a year to get to know the commands I know right now, but I persevered.</li>
								</ul>
							</li>
						</ul>
					</section>

				</section>



				<!-- Sources -->
				<section id="sources">
					<section>
						<h2>Sources</h2>
						<ul>
							<li><a href="http://learn.github.com/">http://learn.github.com/</a></li>
							<li><a href="https://julianscorner.com/wiki/programming/git/visualguide">https://julianscorner.com/wiki/programming/git/visualguide</a></li>
							<li><a href="http://irradiated.net/articles/2010/git-cheat-sheet-overview-tutorial/">http://irradiated.net/articles/2010/git-cheat-sheet-overview-tutorial/</a></li>
							<li><a href="http://learn.github.com/">http://learn.github.com/</a></li>
							<li><a href="http://git-scm.com/book/ch3-1.html">http://git-scm.com/book/ch3-1.html</a></li>
							<li><a href="http://www.youtube.com/watch?v=Wl0NfWYrvlY">http://www.youtube.com/watch?v=Wl0NfWYrvlY</a></li>
						</ul>
					</section>
				</section>

			</div>

			<!-- The navigational controls UI -->
			<aside class="controls">
				<a class="left" href="#">&#x25C4;</a>
				<a class="right" href="#">&#x25BA;</a>
				<a class="up" href="#">&#x25B2;</a>
				<a class="down" href="#">&#x25BC;</a>
				/
			</aside>

			
			
			<!-- Displays presentation progress, max value changes via JS to reflect # of slides -->
			<div class="progress">
			</div>
			<footer>
				<img alt="" src="odisee_2019_helderwit_0.png">
			</footer>
		</div>

		<script src="dist/reveal.js"></script>
		<script src="plugin/notes/notes.js"></script>
		<script src="plugin/zoom/zoom.js"></script>
		<script src="plugin/markdown/markdown.js"></script>
		<script src="plugin/highlight/highlight.js"></script>
		<script>
			// More info about initialization & config:
			// - https://revealjs.com/initialization/
			// - https://revealjs.com/config/
			Reveal.initialize({
				hash: true,
				slideNumber: true,
				// Learn about plugins: https://revealjs.com/plugins/
				plugins: [RevealMarkdown, RevealHighlight, RevealNotes]
			});
		</script>

	</body>
</html>